#include <tagcoll/FilterChain.cc>
#include <tagcoll/InputMerger.cc>
#include <tagcoll/ItemGrouper.cc>
#include <tagcoll/OpSet.cc>
#include <tagcoll/Implications.cc>
#include <tagcoll/Patches.cc>
#include <tagcoll/SmartHierarchy.cc>
#include <tagcoll/TagcollConsumer.cc>
#include <tagcoll/TagCollection.cc>
#include <tagcoll/TagcollFilter.cc>
#include <tagcoll/UnfacetedRemover.cc>
#include <tagcoll/Tag.h>
#include <tagcoll/TagSet.h>
#include <tagcoll/TagToString.cc>

using namespace Tagcoll;

// Instantiate standard tagcoll templates

template class FilterChain<string, string>;
template class InputMerger<string, string>;
template class InputMerger<string, Tag>;
template class ItemGrouper<string, string>;
template class OpSet<string>;
template class OpSet<Tag>;
template class OpSet<Facet>;
template class OpSet<int>;
template class ImplicationList<string>;
template class ApplyImplications<string>;
template class CompressImplications<string>;
template class PatchList<string>;
template class ApplyPatches<string>;
template class SmartHierarchyNode<string, string>;
template class SmartHierarchyNode<string, Tag>;
template class CleanSmartHierarchyNode<string, string>;
template class TagcollConsumer<string, string>;
template class TagcollConsumer<string, Tag>;
template class TagcollConsumer<int, string>;
template class TagcollConsumer<int, Tag>;
template class TagCollection<string, string>;
template class TagCollection<string, Tag>;
template class TagCollection<int, string>;
template class TagCollection<int, Tag>;
template class TagcollFilter<string>;
template class TagsToStrings<string>;
template class StringsToTags<string>;
template class UnfacetedRemover<string>;

// vim:set ts=4 sw=4:
